/* Encoder/Decoder Russian UNICODE page to Samsung C100 Codepage 
 * 
 * Violonix inc. 1995-2004 http://www.violonix.com
 *
 * sendel2000@hotbox.ru 
 * Virca adaptation by Vidar Holen.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 */ 

public class C100_1251 implements Phonepage { 
    
    //ssru - russian alphabetical 33 of chars ; 
    public static int ssru[] = {0x410,0x411,0x412,0x413,0x414,0x415,0x401,0x416,0x417,0x418,0x419,0x41A,0x41B,0x41C,0x41D,0x41E,0x41F,0x420,0x421,0x422,0x423,0x424,0x425,0x426,0x427,0x428,0x429,0x42A,0x42B,0x42C,0x42D,0x42E,0x42F,0x430,0x431,0x432,0x433,0x434,0x435,0x451,0x436,0x437,0x438,0x439,0x43A,0x43B,0x43C,0x43D,0x43E,0x43F,0x440,0x441,0x442,0x443,0x444,0x445,0x446,0x447,0x448,0x449,0x44A,0x44B,0x44C,0x44D,0x44E,0x44F}; 
    public static int ss100[]= {0x041,0x081,0x042,0x03,0x082,0x045,0x045,0x083,0x084,0x085,0x097,0x04b,0x086,0x04d,0x048,0x04f,0x010,0x050,0x043,0x054,0x0dd,0x016,0x058,0x087,0x088,0x089,0x08a,0x06,0x09,0x062,0x08b,0x08d,0x08e,0x061,0x02,0x05,0x07,0x011,0x065,0x065,0x015,0x01a,0x0fe,0x0f0,0x07b,0x07d,0x07f,0x091,0x06f,0x098,0x070,0x063,0x099,0x079,0x09a,0x078,0x0a6,0x0b1,0x0ba,0x0c3,0x0de,0x0e3,0x0cc,0x0fd,0x0cd,0x0d2}; 

    public void init() {}
    public String getName() { return "C100_1251"; }
    public boolean isCompatible() { return true; }

    public String phoneToUnicode(String cz) 
    { 
        StringBuffer tmp= new StringBuffer( "" ); 
        for ( int ss=0;ss<cz.length();ss++) 
        { 
            int i=cz.charAt(ss); 
            for ( int tt=0;tt<ss100.length;tt++) 
            {    
                if (ss100[tt]==i) 
                { 
                    i=( int )ssru[tt]; 
                    break ; 
                } 
            } 
            tmp.append(( char )i); 
        }    
        return tmp.toString(); 
    } 

    public String unicodeToScreen(String ru) 
    { 
        StringBuffer tmp= new StringBuffer( "." ); 
        int k=0; 
        int i=0; 
        for ( int ss=0;ss<ru.length();ss++) 
        { 
            i=ru.charAt(ss); 
            k=0; 
            for ( int tt=0;tt<ssru.length;tt++) 
            {    
                if (( int )ssru[tt]==i) 
                { 
                    i=ss100[k]; 
                    break ; 
                } 
                k++; 
                if (k>32)k=0; 
            } 
            tmp.append(( char )i); 
        }    
        return tmp.toString(); 
    } 
}
    
